// send bugs to: kapolnai@iit.bme.hu

#include <string>
#include <iostream>

using namespace std;

class Allat {
private:
  string nev;
protected:
  enum { tele, ures } bendo;
public:
  Allat(const char *knev) : nev(knev), bendo(ures) {}
  bool isEhes() { return bendo==ures; }
  const char *getNev() { return nev.c_str(); }
  virtual void jatszik(Allat *pajtas) = 0;
  virtual void hallat() = 0;
  virtual ~Allat() {
    cout<< "~" << nev << endl;
  }
};

class Majom : public Allat {
protected:
  static const char* HANG;
public:
  Majom(const char *knev) : Allat(knev) { }
  void jatszik(Allat *pajtas) {
    this->hallat();
    pajtas->hallat();
  }
  void hallat() { cout << HANG << ":" << getNev() << endl; }
  ~Majom() { cout << HANG << HANG << " "; }
};

const char* Majom::HANG = "Mak";

class Tigris : public Allat {
public:
  Tigris(const char *knev) : Allat(knev) { }
  void jatszik(Allat *pajtas) {
    delete pajtas;
    bendo = tele;
  }
  void hallat() { cout << "HRRR" << endl;}
};

class CirkusziTigris : private Tigris {
public:
  CirkusziTigris(const char *knev) : Tigris(knev) { }
  void hallat() {
    Tigris::hallat();
    cout << getNev() << " vagyok, idomított tigris.\n";
  }
};

int main() {
  Allat *cicus = new Tigris("Cicus");
  Allat *csita = new Majom("Csita");
  Allat *tarzan = new Majom("ÁIÁIÁIÁ");
  cout << "-= Csita játszik =-" << endl;
  csita->jatszik(tarzan);
  csita->jatszik(cicus);
  cout << "-= Cicus játszik =-" << endl;
  cicus->jatszik(csita);
  cicus->jatszik(tarzan);
  cout << "-= Attrakció =-" << endl;
  CirkusziTigris *ubul = new CirkusziTigris("Ubul");
  ubul->hallat();
  delete cicus;
  delete ubul;
  return 0;
}
